############################################
#                                  Mail Notifyer - AeroSys theme                                     #
#                     By Adrien Vermeulen - Released under GPL                        #
############################################

 #this import statement allows access to the karamba functions
import karamba
import re
import poplib
import sys
from Tkinter import *

sys.argv = [""]
server1 = ""
server2 = ""
servername1=""
servername2=""
username1 = ""
username2 = ""
password1 = ""
password2 = ""
red = 255
green = 255
blue = 255
color_pid = None
custom_pid = None

def updateText(widget, r, g, b):
	karamba.changeTextColor(widget, textServer1, r, g, b)
	karamba.changeTextColor(widget, textServer2, r, g, b)
	karamba.changeTextColor(widget, titleText, r, g, b)
	
def updateText2(widget, r, g, b):
	karamba.changeTextColor(widget, textNum1, r, g, b)
	karamba.changeTextColor(widget, textNum2, r, g, b)

#this is called when you click on "Configure your account(s)" in the configure Menu
def configWindow(widget) :
    def resultat() :
        global servername1, server1, username1, password1, servername2, server2, username2, password2, desiredMode
    
        servername1 = str(entr1.get())
        server1 = str(entr2.get())
        username1 = str(entr3.get())
        password1 = str(entr4.get())
    
        servername2 = str(entr5.get())
        server2 = str(entr6.get())
        username2 = str(entr7.get())
        password2 = str(entr8.get())
        fen.destroy()
    
        print "## First Account ##"
        print "server name 1 : " + servername1
        print "server 1      : " + server1
        print "username 1    : " + username1
        print ""
        print "## Second Account ##"
        print "server name 2 : " + servername2
        print "server 2      : " + server2
        print "username 2    : " + username2
        
        karamba.writeConfigEntry(widget, "servername1", servername1)
        karamba.writeConfigEntry(widget, "server1", server1)
        karamba.writeConfigEntry(widget, "username1", username1)
        karamba.writeConfigEntry(widget, "password1", password1)

        karamba.writeConfigEntry(widget, "servername2", servername2)
        karamba.writeConfigEntry(widget, "server2", server2)
        karamba.writeConfigEntry(widget, "username2", username2)
        karamba.writeConfigEntry(widget, "password2", password2)


    fen = Tk()
    chk = IntVar()
    fen.title("Account(s) configuration")
    title1 = Label(fen, text = "First Account")
    title2 = Label(fen, text = "Second Account")
    txt1 = Label(fen, text = "Server Name to display :")
    txt2 = Label(fen, text = 'Server (pop or "gmail") :')
    txt3 = Label(fen, text = "Username :")
    txt4 = Label(fen, text = "Password :")
    entr1, entr2, entr3, entr4, entr5, entr6, entr7, entr8 = Entry(fen), Entry(fen), Entry(fen), Entry(fen, show="*"), Entry(fen), Entry(fen), Entry(fen), Entry(fen, show="*")
    entr1.insert(0, servername1)
    entr2.insert(0, server1)
    entr3.insert(0, username1)
    entr4.insert(0, password1)
    entr5.insert(0, servername2)
    entr6.insert(0, server2)
    entr7.insert(0, username2)
    entr8.insert(0, password2)
    boutOk = Button(fen, text = "Apply", command = resultat)

    title1.grid(row = 1, column = 2)
    title2.grid(row = 1, column = 3)
    txt1.grid(row = 2, sticky = E)
    txt2.grid(row = 3, sticky = E)
    txt3.grid(row = 4, sticky = E)
    txt4.grid(row = 5, sticky = E)
    entr1.grid(row = 2, column = 2)
    entr2.grid(row = 3, column = 2)
    entr3.grid(row = 4, column = 2)
    entr4.grid(row = 5, column = 2)
    entr5.grid(row = 2, column = 3)
    entr6.grid(row = 3, column = 3)
    entr7.grid(row = 4, column = 3)
    entr8.grid(row = 5, column = 3)
    boutOk.grid(row = 6, column = 3)

    fen.mainloop()

#def getMailNum(widget, server, login, passw):
#    m = poplib.POP3(server)
#    m.user(login)
#    m.pass_(passw)
#    out = m.stat()
#    m.quit()
#    return out[0]

    
def updateServerName(widget) :
    global servername1, servername2, textServer1, textServer2
    karamba.changeText(widget, textServer1, servername1)
    karamba.changeText(widget, textServer2, servername2 )
    karamba.redrawWidget(widget)


#this is called when your widget is initialized
def initWidget(widget):
    global textServer1, textNum1, textServer2, textNum2, servername1, server1, username1, password1, servername2, server2, username2, password2, red, green, blue, titleText, red2, green2, blue2
    karamba.createBackgroundImage(widget, 0, 0, "img/bg-mail.png")
    test = karamba.readConfigEntry(widget,"server1")
    if ( test != None ) :
        server1 = test
        servername1 = karamba.readConfigEntry(widget, "servername1")
        username1 = karamba.readConfigEntry(widget, "username1")
        password1 = karamba.readConfigEntry(widget, "password1")

        servername2 = karamba.readConfigEntry(widget, "servername2")
        server2 = karamba.readConfigEntry(widget, "server2")
        username2 = karamba.readConfigEntry(widget, "username2")
        password2 = karamba.readConfigEntry(widget, "password2")

    textServer1 = karamba.createText(widget, 28, 47, 94, 14, "")
    karamba.changeTextColor(widget, textServer1, 255, 255, 255)
    karamba.setTextAlign(widget, textServer1, "CENTER")
    textNum1 = karamba.createText(widget, 64, 26, 22, 12, "")
    karamba.setTextAlign(widget, textNum1, "CENTER")
    titleText = karamba.createText(widget, 25, 61, 100, 24, "Mail")
    karamba.setTextAlign(widget, titleText, "CENTER")
    karamba.changeTextSize(widget, titleText, 20)
    karamba.changeTextFont(widget, titleText, "verdana")
      
    textServer2 = karamba.createText(widget, 28, 89, 94, 14, "")
    karamba.changeTextColor(widget, textServer2, 255, 255, 255)
    karamba.setTextAlign(widget, textServer2, "CENTER")
    textNum2 = karamba.createText(widget, 64, 112, 22, 12, "")
    karamba.setTextAlign(widget, textNum2, "CENTER")

    red = karamba.readConfigEntry(widget, "red")
    green = karamba.readConfigEntry(widget, "green")
    blue = karamba.readConfigEntry(widget, "blue")
    if ( red != None and green != None and blue != None ):
        updateText(widget, red, green, blue)

    red2 = karamba.readConfigEntry(widget, "red2")
    green2 = karamba.readConfigEntry(widget, "green2")
    blue2 = karamba.readConfigEntry(widget, "blue2")
    if ( red2 != None and green2 != None and blue2 != None ):
        updateText2(widget, red2, green2, blue2)
      
    karamba.addMenuConfigOption(widget, "mode", "Configure your account(s)")
    karamba.addMenuConfigOption(widget, "colorclick", "Change text color")
    karamba.addMenuConfigOption(widget, "colorclick2", "Change numbers color")
    karamba.setMenuConfigOption(widget, "mode", 0)
    karamba.setMenuConfigOption(widget, "colorclick", 0)
    karamba.setMenuConfigOption(widget, "colorclick2", 0)
    
    updateServerName(widget)

    widgetUpdated(widget)

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    global servername1, server1, username1, password1, servername2, server2, username2, password2, textNum1, textNum2, textServer1, textServer2, pidNum1, pidNum2
    path = karamba.getThemePath(widget)
    if ( server1 == 'gmail' ):
        num1Command = ["python", path + "script/getGMail.py", username1, password1]
    else:
        num1Command = ["python", path + "script/getNumMail.py", server1, username1, password1]
    if ( server2 == 'gmail' ):
        num2Command = ["python", path + "script/getGMail.py", username2, password2]
    else:
        num2Command = ["python", path + "script/getNumMail.py", server2, username2, password2]
    
    if ( server1 != "" ) :
      pidNum1 = karamba.executeInteractive(widget, num1Command)
      #num1 = getMailNum(widget, server1, username1, password1)
      #karamba.changeText(widget, textNum1, str(num1))
      #print str(num1) + " new message(s) on " + server1
    else :
      karamba.changeText(widget, textServer1, "No configuration")
      karamba.redrawWidget(widget)
    if ( server2 != "" ) :
      pidNum2 = karamba.executeInteractive(widget, num2Command)
      #num2 = getMailNum(widget, server2, username2, password2)
      #karamba.changeText(widget, textNum2, str(num2))
      #print str(num2) + " new message(s) on " + server2
    else :
        karamba.changeText(widget, textServer2, "No pop server")
        karamba.redrawWidget(widget)
    print "Widget updated!"

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    global  diseredMode, color_pid, textselect
    if ( key == "mode" ):
      karamba.setMenuConfigOption(widget, "mode", 0)
      configWindow(widget)
      updateServerName(widget)
      widgetUpdated(widget)

    if ( key == "colorclick" ):
        karamba.setMenuConfigOption(widget, "colorclick", 0)
        textselect = 1
        color_command = ["kdialog", "--title", "Aero-G", "--menu", "Please select a text color:", "custom", "Custom", "white", "White", "green", "Green", "blue", "Blue", "yellow", "Yellow", "orange", "Orange", "red", "Red", "pink", "Pink", "lavande", "Lavande", "grey", "Grey"]
        color_pid = karamba.executeInteractive(widget, color_command)

    if ( key == "colorclick2" ):
        textselect = 2
        karamba.setMenuConfigOption(widget, "colorclick2", 0)
        color_command = ["kdialog", "--title", "Aero-G", "--menu", "Please select a text color:", "custom", "Custom", "white", "White", "green", "Green", "blue", "Blue", "yellow", "Yellow", "orange", "Orange", "red", "Red", "pink", "Pink", "lavande", "Lavande", "grey", "Grey"]
        color_pid = karamba.executeInteractive(widget, color_command)

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.  
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    pass

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
	global pidNum1, pidNum2, color_pid, custom_pid,  textselect

	if ( pid == pidNum1 ) :
		num1 = output.replace('\n','')
		karamba.changeText(widget, textNum1, num1)
		print str(num1) + " new message(s) on " + server1
		karamba.redrawWidget(widget)
	
	if ( pid == pidNum2 ) :
		num2 = output.replace('\n','')
		karamba.changeText(widget, textNum2, num2)
		print str(num2) + " new message(s) on " + server2
		karamba.redrawWidget(widget)

	if ( pid == color_pid ):
		textColor = output.replace('\n','')
		if ( textColor == "custom" ):
			custom_command = ["kdialog", "--title", "Aero-G", "--inputbox", "Enter a color in this format: r=xxx g=xxx b=xxx where xxx are integers in [0,255]", "r= g= b="]
			custom_pid = karamba.executeInteractive(widget, custom_command)
		else:
			if ( textColor == "white" ):
				red = 255
				green = 255
				blue = 255
			if ( textColor == "green" ):
				red = 132
				green = 255
				blue = 103
			if ( textColor == "blue" ):
				red = 122
				green = 178
				blue = 255
			if ( textColor == "yellow" ):
				red = 255
				green = 216
				blue = 0
			if ( textColor == "orange" ):
				red = 255
				green = 131
				blue = 49
			if ( textColor == "red" ):
				red = 255
				green = 73
				blue = 73
			if ( textColor == "pink" ):
				red = 255
				green = 122
				blue = 206
			if ( textColor == "lavande" ):
				red = 171
				green = 141
				blue = 255
			if ( textColor == "grey" ):
				red = 184
				green = 184
				blue = 184
			if ( textselect == 1 ):
				updateText(widget, red, green, blue)
				karamba.writeConfigEntry(widget, "red", str(red))
				karamba.writeConfigEntry(widget, "green", str(green))
				karamba.writeConfigEntry(widget, "blue", str(blue))
			if ( textselect == 2 ):
				updateText2(widget, red, green, blue)
				karamba.writeConfigEntry(widget, "red2", str(red))
				karamba.writeConfigEntry(widget, "green2", str(green))
				karamba.writeConfigEntry(widget, "blue2", str(blue))
			karamba.redrawWidget(widget)
	
	if ( pid == custom_pid ):
		entry = output.replace('\n','')
		match = re.search("r=([0-9]+) g=([0-9]+) b=([0-9]+)", entry)
		if ( match == None ):
			error_command = ['kdialog', '--title',  'Formatting Error', '--error', 'Please enter information in the correct format.']
			karamba.executeInteractive(widget, error_command)
		else:
			red = int(match.group(1))
			green = int(match.group(2))
			blue = int(match.group(3))
			if ( red < 0 or green < 0 or blue < 0 or red > 255 or green > 255 or blue > 255 ):
				error_command = ['kdialog', '--title',  'Formatting Error', '--error', 'Please enter information in the correct format: r, g, b values may not be greater than 255 or inferior to 0.']
				karamba.executeInteractive(widget, error_command)
			else:
				if ( textselect == 1 ):
					updateText(widget, red, green, blue)
					karamba.writeConfigEntry(widget, "red", str(red))
					karamba.writeConfigEntry(widget, "green", str(green))
					karamba.writeConfigEntry(widget, "blue", str(blue))
				if ( textselect == 2 ):
					updateText2(widget, red, green, blue)
					karamba.writeConfigEntry(widget, "red2", str(red))
					karamba.writeConfigEntry(widget, "green2", str(green))
					karamba.writeConfigEntry(widget, "blue2", str(blue))
				karamba.redrawWidget(widget)

#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
def itemDropped(widget, dropText):
    pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.  
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.  
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.  
def taskRemoved(widget, task):
    pass

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).  
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass

# This will be printed when the widget loads.
print "Loaded Aero-G Mail python extension!"
